/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {

dojo.provide("com.ibm.rational.report.web.core.app.internal.common.SideNavSection");

dojo.require("com.ibm.rational.report.web.core.app.internal.common.NavSection");

var DROPDOWN_HOVER	= dojo.moduleUrl("com.ibm.rational.report.web.core", "app/internal/common/icons/dd-arrow-hov.gif");
var DROPDOWN		= dojo.moduleUrl("com.ibm.rational.report.web.core", "app/internal/common/icons/dd-arrow.gif");

dojo.declare(
	"com.ibm.rational.report.web.core.app.internal.common.SideNavSection",
	com.ibm.rational.report.web.core.app.internal.common.NavSection, {
	
	postCreate: function() {
		this._dropDownImage.src = DROPDOWN;
		this._menu = this.menu;
		this.inherited("postCreate", arguments);
		
		this._dropDown.style.visibility = "hidden";
		this._dropDown.style.display = "none";
				
		this._isMenuOpen = false;
		this._mouseOutOccurred = false;
		
		this._dropDownImage.alt = CommonMessages.OPEN_ALT_LABEL;
		var self = this;
		
		// Hook the events for the drop-down indicator
		dojo.connect(this._titleItem, "onmouseover", null,
				function(e) {
					e.preventDefault();
					self._titleItem.className = "titleItemSelected";
					if (self._menu) {
						self._dropDown.style.visibility = "visible";
						self._dropDown.style.display = "inline";
					}
					self._mouseOutOccurred = false;	
				}
			);
			
		dojo.connect(this._linkCompactTable, "onfocus", null,
				function(e) {
					e.preventDefault();
					self._titleItem.className = "titleItemSelected";
					if (self._menu) {
						self._dropDown.style.visibility = "visible";
						self._dropDown.style.display = "inline";
						self._dropDownImage.src = DROPDOWN;
					}
					self._mouseOutOccurred = false;	
				}
			);
			
		dojo.connect(this._togglerLink, "onfocus", null,
				function(e) {
					e.preventDefault();
					self._titleItem.className = "titleItemSelected";
					if (self._menu) {
						self._dropDown.style.visibility = "visible";
						self._dropDown.style.display = "inline";
						self._dropDownImage.src = DROPDOWN;
					}
					self._mouseOutOccurred = false;	
				}
			);
			
		dojo.connect(this._linkCompactTable, "onblur", null,
				function(e) {
					e.preventDefault();
					if (self._isMenuOpen) {
						self._mouseOutOccurred = true;
						return;
					}
					self._titleItem.className = "titleItem";
					self._dropDown.style.visibility = "hidden";
					self._dropDown.style.display = "none";
				}
			);
			
		dojo.connect(this._dropDown, "onfocus", null,
			function(e) {
				e.preventDefault();
				self._dropDownImage.src = DROPDOWN_HOVER;
			}
		);
		
		dojo.connect(this._dropDown, "onblur", null,
			function(e) {
				e.preventDefault();
				if(!self._isMenuOpen){
					self._dropDown.style.visibility = "hidden";
					self._dropDown.style.display = "none";
					self._dropDownImage.src = DROPDOWN;
					self._titleItem.className = "titleItem";
				}
			}
		);
		
		dojo.connect(document, "onkeypress", 
			function(e){
				if(e.keyCode == 27 && self._isMenuOpen){
					self._closeMenu();
					self._dropDown.style.visibility = "visible";
					self._dropDown.style.display = "inline";
					self._dropDownImage.src = DROPDOWN;
					self._dropDown.focus();
				}
			}
		);
			
		dojo.connect(this._titleItem, "onmouseout", null,
				function(e) {
					e.preventDefault();
					if (self._isMenuOpen) {
						self._mouseOutOccurred = true;
						return;
					}
					self._titleItem.className = "titleItem";
					self._dropDown.style.visibility = "hidden";
					self._dropDown.style.display = "none";
				}
			);
			
		if (self._menu == null )
			return;
						
		dojo.connect(this._dropDownImage, "onmouseover", null,
				function(e) {
					e.preventDefault();
					self._dropDownImage.src = DROPDOWN_HOVER;
				}
			);
			
		dojo.connect(this._dropDownImage, "onmouseout", null,
				function(e) {
					e.preventDefault();
					self._dropDownImage.src = DROPDOWN;
				}
			);	
		
		dojo.connect(this._dropDown, "onclick", null,
				function(e) {
					e.preventDefault();
					self._openMenu(e);
				}
		   );		 
	},
	
	_openMenu: function(e) {
			this._dropDownImage.src = DROPDOWN;
        	if (this._isMenuOpen) {
            	this._closeMenu();
            	return;
        	}
			var coords = dojo.coords(e.target, true);
			dijit.popup.open({ popup: this._menu, parent: this, x: coords.x + 10, y: coords.y + 10, onExecute: dojo.hitch(this,this._closeMenu),orient: 'BL' });
			//register event handler that causes menu to close
			this._menuCloseOnBody = this.connect(this._menu,"_onBlur",this._closeMenu);
			this._isMenuOpen = true;	
			this._menu.focus();		
		},
		
		_closeMenu: function(e){
			this._isMenuOpen = false;
			if (e) {
				dojo.stopEvent(e);
			}
			if (this._mouseOutOccurred) {
				this._titleItem.className = "titleItem";
				this._dropDown.style.visibility = "hidden";
				this._dropDown.style.display = "none";
			}
			this.disconnect(this._menuCloseOnBody);
			dijit.popup.close(this._menu);
		}
});
})();